// Bits is Bits
// Eric Mika, ITP Math Driveby, October 14 2010

// A potential use for arbitrary-precision arithmetic libraries.
// This sketch generates the first few images in the sequence of every
// possible 16 x 16 pixel black and white image.

import java.math.BigInteger;

PImage targetImage;
BigInteger index = new BigInteger("2");    //bit depth
BigInteger xNumber = new BigInteger("0");  //total pixels
BigInteger yNumber = new BigInteger("0");  //total pixels
int yOffset = -16;

void setup() {
  size(1024, 1024);
  frameRate(600);
  background(128);

  targetImage = new PImage(16, 16);
}

void draw() {
  // paste together the bignumbs
  String xString = padString(xNumber.toString(2));
  String yString = padString(yNumber.toString(2));
  String imageString = xString + yString;

  if((((frameCount - 1) * 16) % height == 0) && (frameCount != 0)) yOffset += 16;

  fill(255, 255);
  StringToImage(imageString);
  image(targetImage, ((frameCount - 1) * 16) % width, yOffset % height);
  
  xNumber = increment(xNumber);
  yNumber = increment(yNumber);
  println(xNumber.toString(2));

  //println(imageString);
  if(frameCount == 64 * 64) {
    save("frameCount.tif");
  }
}

//just put this in an extended BigInteger class?
void StringToImage(String imageString) {
  targetImage.loadPixels();
    for(int i = 0; i < 256; i++)  {
      if(imageString.charAt(i) == '1') {
        //paint ones as white
        targetImage.pixels[i] = color(255);
      }
      else {
        //paint zeros as black
        targetImage.pixels[i] = color(0);
      }
    }
    targetImage.updatePixels();
}

BigInteger increment(BigInteger input) {
  input = input.add(new BigInteger("1"));
  return input;
}

BigInteger imageToInt(PImage sourceImage) {
  String tempString = "";

  for(int i = 0; i < 256; i++)  {
    if(sourceImage.pixels[i] == -1) {
      tempString = tempString + "1";
    }
    else {
      tempString = tempString + "0";
    }
  }

  return new BigInteger(tempString, 2);
}

PImage intToImage(BigInteger sourceInt) {
  PImage resultImage = new PImage(16, 16);
  String binString = sourceInt.toString(2);

  binString = padString(binString);

  resultImage.loadPixels();
  for(int i = 0; i < 256; i++)  {
    if(binString.charAt(i) == '1') {
      //paint ones as white
      resultImage.pixels[i] = color(255);
    }
    else
    {
      //paint zeros as black
      resultImage.pixels[i] = color(0);
    }
  }
  resultImage.updatePixels();

  return resultImage;
}

void refreshImage(BigInteger sourceInt, PImage sourceImage) {
  String binString = sourceInt.toString(2);
  binString = padString(binString);

  sourceImage.loadPixels();

  for(int i = 0; i < 256; i++)
  {
    if(binString.charAt(i) == '1')
    {
      //paint ones as white
      sourceImage.pixels[i] = color(255);
    }
    else
    {
      //paint zeros as black
      sourceImage.pixels[i] = color(0);
    }
  }
  sourceImage.updatePixels();

}

String padString(String input) {
  while(input.length() < 128)  {
    input = "0" + input;
  }

  return input;
}
